=begin
#Datadog API V1 Collection

#Collection of all Datadog Public endpoints.

The version of the OpenAPI document: 1.0
Contact: support@datadoghq.com
Generated by: https://openapi-generator.tech

 Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
 This product includes software developed at Datadog (https://www.datadoghq.com/).
 Copyright 2020-Present Datadog, Inc.

=end

require 'date'
require 'time'

module DatadogAPIClient::V1
  # Response with properties for each aggregated usage type.
  class UsageBillableSummaryBody
    # The total account usage.
    attr_accessor :account_billable_usage

    # Elapsed usage hours for some billable product.
    attr_accessor :elapsed_usage_hours

    # The first billable hour for the org.
    attr_accessor :first_billable_usage_hour

    # The last billable hour for the org.
    attr_accessor :last_billable_usage_hour

    # The number of units used within the billable timeframe.
    attr_accessor :org_billable_usage

    # The percentage of account usage the org represents.
    attr_accessor :percentage_in_account

    # Units pertaining to the usage.
    attr_accessor :usage_unit

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'account_billable_usage' => :'account_billable_usage',
        :'elapsed_usage_hours' => :'elapsed_usage_hours',
        :'first_billable_usage_hour' => :'first_billable_usage_hour',
        :'last_billable_usage_hour' => :'last_billable_usage_hour',
        :'org_billable_usage' => :'org_billable_usage',
        :'percentage_in_account' => :'percentage_in_account',
        :'usage_unit' => :'usage_unit'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'account_billable_usage' => :'Integer',
        :'elapsed_usage_hours' => :'Integer',
        :'first_billable_usage_hour' => :'Time',
        :'last_billable_usage_hour' => :'Time',
        :'org_billable_usage' => :'Integer',
        :'percentage_in_account' => :'Float',
        :'usage_unit' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `DatadogAPIClient::V1::UsageBillableSummaryBody` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `DatadogAPIClient::V1::UsageBillableSummaryBody`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'account_billable_usage')
        self.account_billable_usage = attributes[:'account_billable_usage']
      end

      if attributes.key?(:'elapsed_usage_hours')
        self.elapsed_usage_hours = attributes[:'elapsed_usage_hours']
      end

      if attributes.key?(:'first_billable_usage_hour')
        self.first_billable_usage_hour = attributes[:'first_billable_usage_hour']
      end

      if attributes.key?(:'last_billable_usage_hour')
        self.last_billable_usage_hour = attributes[:'last_billable_usage_hour']
      end

      if attributes.key?(:'org_billable_usage')
        self.org_billable_usage = attributes[:'org_billable_usage']
      end

      if attributes.key?(:'percentage_in_account')
        self.percentage_in_account = attributes[:'percentage_in_account']
      end

      if attributes.key?(:'usage_unit')
        self.usage_unit = attributes[:'usage_unit']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          account_billable_usage == o.account_billable_usage &&
          elapsed_usage_hours == o.elapsed_usage_hours &&
          first_billable_usage_hour == o.first_billable_usage_hour &&
          last_billable_usage_hour == o.last_billable_usage_hour &&
          org_billable_usage == o.org_billable_usage &&
          percentage_in_account == o.percentage_in_account &&
          usage_unit == o.usage_unit
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [account_billable_usage, elapsed_usage_hours, first_billable_usage_hour, last_billable_usage_hour, org_billable_usage, percentage_in_account, usage_unit].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when :Array
        # generic array, return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = DatadogAPIClient::V1.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
